"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactSimpleCodeEditor = _interopRequireDefault(require("react-simple-code-editor"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function getLineNumber(codeString, selectionStart) {
  return codeString.substring(0, selectionStart).split('\n').length;
}

function getSelectionState(editorElement) {
  return {
    end: editorElement.selectionEnd,
    start: editorElement.selectionStart
  };
}

function createReducer(options) {
  return function reducer(state, action) {
    switch (action.type) {
      case 'EDIT':
        {
          return _objectSpread({}, state, {
            code: action.payload
          });
        }

      case 'COMMENT_LINE':
        {
          var _action$payload = action.payload,
              lineNumber = _action$payload.lineNumber,
              selectionState = _action$payload.selectionState;
          var didRemoveComment = false;
          var newCode = state.code.split('\n').reduce(function (newCode, line, lineIndex) {
            if (lineIndex + 1 === lineNumber) {
              // @TODO use block comments if within render method
              // Probably requires some kind of jsx and/or look[ahead / behind] searching
              if (line.startsWith('// ')) {
                didRemoveComment = true;
              }

              return [].concat(_toConsumableArray(newCode), [line.startsWith('// ') ? line.split('// ')[1] : "// ".concat(line)]);
            }

            return [].concat(_toConsumableArray(newCode), [line]);
          }, []).join('\n');
          return _objectSpread({}, state, {
            selectionState: selectionState,
            code: newCode,
            didRemoveComment: didRemoveComment
          });
        }

      case 'FORMAT_CODE':
        {
          return _objectSpread({}, state, {
            code: options.formatCode(state.code),
            selectionState: action.payload
          });
        }

      default:
        return state;
    }
  };
}

function ComplexEditor(_ref) {
  var initialValue = _ref.initialValue,
      formatCode = _ref.formatCode,
      formatOnSave = _ref.formatOnSave,
      props = _objectWithoutProperties(_ref, ["initialValue", "formatCode", "formatOnSave"]);

  var _useReducer = (0, _react.useReducer)(createReducer({
    formatCode: formatCode
  }), {
    code: initialValue,
    selectionState: {
      end: 0,
      start: 0
    },
    didRemoveComment: false
  }),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var editorRef = (0, _react.useRef)(null);
  var isMacRef = (0, _react.useRef)(false);
  (0, _react.useEffect)(function () {
    // Do initial setup of the refs, we use one to store the textarea instance
    // and another to determine if we are on a mac or not to switch keyboard shortcuts
    editorRef.current = document.querySelector('#react-complex-code-editor--element');
    isMacRef.current = navigator.userAgent.includes('Mac OS X');
  }, []);
  (0, _react.useEffect)(function () {
    // set the start and end selection states to the start before
    // the comment started. This is because we only support single line comments
    // so we want to restore the cursor to where it was or where it should be
    // depending on if we are removing the comment or adding it.
    editorRef.current.selectionEnd = state.didRemoveComment ? state.selectionState.start - 3 : state.selectionState.start + 3;
    editorRef.current.selectionStart = state.didRemoveComment ? state.selectionState.start - 3 : state.selectionState.start + 3;
  }, [state.selectionState, state.didRemoveComment]);
  var handleKeyDown = (0, _react.useCallback)(function (event) {
    // If the key is a slash and the user is using a mac and holding the "meta" (aka command) key
    // or if the key is a slash and the user is using a pc and holding the control key
    // then we want to comment out the current line the cursor is on
    if (event.key === '/' && isMacRef.current && event.metaKey || event.key === '/' && !isMacRef.current && event.ctrlKey) {
      var selectionState = getSelectionState(editorRef.current);
      var lineNumber = getLineNumber(state.code, selectionState.start);
      dispatch({
        type: 'COMMENT_LINE',
        payload: {
          lineNumber: lineNumber,
          selectionState: selectionState
        }
      });
    } else if ( // If the formatOnSave is enabled, and the formatCode prop is a function
    // and if the user is on mac and they pressed command + s
    // or if the user is on windows and they pressed control + s
    typeof formatCode === 'function' && formatOnSave && (event.key === 's' && isMacRef.current && event.metaKey || event.key === 's' && !isMacRef.current && event.ctrlKey) || event.key === 'f' && isMacRef.current && event.metaKey || event.key === 'f' && !isMacRef.current && event.ctrlKey) {
      var _selectionState = getSelectionState(editorRef.current); // prevent default to not show the default save page popup


      event.preventDefault();
      dispatch({
        type: 'FORMAT_CODE',
        payload: _selectionState
      });
    }
  }, [state.code]);
  var onValueChange = (0, _react.useCallback)(function (code) {
    return dispatch({
      type: 'EDIT',
      payload: code
    });
  }, []);
  return _react["default"].createElement(_reactSimpleCodeEditor["default"], _extends({}, props, {
    value: state.code,
    onValueChange: onValueChange,
    textareaId: "react-complex-code-editor--element",
    onKeyDown: handleKeyDown
  }));
}

var _default = ComplexEditor;
exports["default"] = _default;